<template>
  <view class="weighingDevice">
    <div class="shuaxinBtn">
      <u-button
          @click="refreshClick"
          type="primary"
          :plain="true">点击刷新</u-button>
    </div>
    <view class="one"
          :style="{ backgroundImage: `url(${onlineurl}/appimg/image/banner/weighbanner.png)`, backgroundSize: 'cover', backgroundRepeat: 'no-repeat' }">
      <view class="top">
        <view class="top_left">
          <!-- <text>{{ realTimeWeigh }}</text> -->
          <text>{{ globalweigh }}</text>
        </view>
        <view class="top_right">
          <view class="">
            称重:
            <u--text :type="weightStatusType"
                     :text="weightStatus"
                     size="34"></u--text>
          </view>
          <view class="">
            红外:
            <u--text :type="globalinfraredStatus ? 'error' : 'success'"
                     :text="globalinfraredStatus ? '未安装' : '正常'"
                     size="34"></u--text>
          </view>
        </view>
      </view>
      <view class="bottom"><text>当前状态为正常时可以称重</text></view>
    </view>
    <view class="bottom-block">
      <view class="block-main">


        <view class="main-information"
              >
          <view class="prefix">客户:</view>
          <view class="suffix">{{ weighList.customerName|| '' }}</view>
        </view>
        <view class="main-information"
             >
          <view class="prefix">仓库:</view>
          <view class="suffix">{{ weighList.deptName || '' }}</view>
        </view>
        <view class="main-information"
              >
          <view class="prefix">基地:</view>
          <view class="suffix">{{ weighList.filedName || '' }}</view>
        </view>
        <!-- <view class="main-information">
          <view class="prefix">物料名称:</view>
          <view class="suffix">{{ weighList.coalName || '' }}</view>
        </view> -->
        <view class="main-information">
          <view class="prefix">订单类型:</view>
          <view class="suffix">{{ weighList.orderType || '' }}</view>
        </view>
        <view class="main-information">
          <view class="prefix">产品:</view>
          <view class="suffix">{{ weighList.coalName || '' }}</view>
        </view>
        <view class="main-information">
          <view class="prefix">车牌号:</view>
          <view class="suffix">{{ weighList.noCarNo == 1 ? '无车牌' : weighList.carNo }}</view>
        </view>
<!--        xsUser1Name-->
        <view class="main-information">
          <view class="prefix">司机姓名:</view>
          <view class="suffix">{{ weighList.xsUser1Name || '' }}</view>
        </view>
        <!-- <view class="main-information"  v-if="isweight">
          <view class="prefix">皮重:</view>
          <view class="suffix">
            {{currentSkin}}
          </view>
        </view>
        <view class="main-information"  v-if="isweight">
          <view class="prefix">毛重:</view>
          <view class="suffix">
            {{currentHair}}
          </view>
        </view>
        <view class="main-information" v-if="isweight">
          <view class="prefix">净重:</view>
          <view class="suffix">
            {{ currentClean}}
          </view>
        </view>
        <view class="main-information" v-else>
          <view class="prefix">净重:</view>
          <view class="suffix">
            {{ isWeightclean}}
          </view>
        </view> -->
        <!-- <view class="main-information">
          <view class="prefix">订单余量:</view>
          <view class="suffix">{{ weighList.orderSurplus || 0 }}</view>
        </view> -->
      </view>
    </view>
    <!--  称重历史-->
    <weigh-item :list="weighHistory" class="weighingDecive-item"></weigh-item>
    <view class="chengzhong-btn" v-if="applyHouseId && noCarNo == 1 && status == 15 && roleType == 4">
    <!--   applyHouseId有磅房号，noCarNo=1(无车牌号)，status=15,质检员 把符合上面条件的加上称重按钮   -->
      <u-button type="primary"
                text="确定称重"
                :loading="isConfirmWeighLoading"
                loadingText="确认"
                @click="confirmWeigh"></u-button>
    </view>
    <!--  iszj，是否已质检字段  质检员身份+有tmId+质检之前  -->
    <view class="chengzhong-btn marginTop" v-if="weighData.tmId && roleType == 4">
      <!--   收发单信息时   -->
      <u-button type="primary"
                text="复磅"
                :loading="repeatWeighLoading"
                loadingText="确认"
                @click="confirmRepeatWeigh"></u-button>
    </view>
  </view>
</template>

<script>
import { webSocketUrl, onlineurl } from '@/api/request.js';
import { mapState, mapMutations,mapGetters } from 'vuex';
import combinedTitle from '@/components/combined-title/combined-title.vue';
import weighItem from '@/components/weighItem.vue'
export default {
  onLoad(params) {
    console.log(params,'params===')
    this.tmId = params?.tmId || '';  //提煤单id
    this.weighData.sceneId = params?.houseId; //磅房id
    this.changeweighHouseCode(params?.weighHouseCode);
    this.changeWeigh('')
  },
  components: {
    combinedTitle,
    weighItem
  },
  data() {
    return {
      isWeighing:'',
      timer:null,
      weighData: {
        //确认称重接口参数
        deptId: '',
        tmId: '',
        sceneId: '',
        carNo: '',
        gateCameraId: '',
        equipmentCode: '',
        weigh: 0,
        tmCode: '',
        sceneInOut: '',
        // coalContactClean: 0,
        // coalContactHair: 0,
        // coalContactSkin: 0
      },
      // 是否填写原发信息
      isInputOrigin: false,
      haveInputOrigin: false,

      tmId: null,
      weighHouseCode: '',
      isConfirmWeighLoading: false, //确定称重按钮
      repeatWeighLoading: false,  //复磅
      realTimeWeigh: 0,
      weighList: {},
      // 临时称重对象
      temporaryWeighObj: {
        skin: null,
        hair: null,
        clean: null,
        isWeightclean:null,
      },
      infraredStatus: false, // 红外状态，
      // 放空控制
      evacuationModalShow: false,
      evacuationTitle: '放空确认',
      evacuationContent: '是否确认放空',
      // 获取原发信息
      primarySkin: null,
      primaryHair: null,
      primaryClean: null,
      // 判断称重按钮是否可用
      isweigh: false,
      // 外购类型称重填写毛，皮，
      firstHairCustomernameShow: false,
      coalContactHair: '',
      coalContactSkin: '',
      // 聚焦时改变样式
      isfocus1: false,
      isfocus2: false,
      // 外购类型
      outBuy: true,
      // 继续卸货按钮
      canUnload: false,
      UnloadingAgainLoading: false,
      onlineurl,
      applyHouseId:'',  //磅房号
      noCarNo:0,  //是否有车牌号(有车牌0，无车牌1)
      status:null,  //状态
    };
  },
  watch: {
    realTimeWeigh(newV, oldV) {

    },
    // 监听重量变化
    globalweigh: {
      handler: function(newV) {
        console.log(newV,'newV===')
        if(newV) {
          this.weighData.weigh = this.realTimeWeigh = newV;
          if  ((this.weighList.orderType == '外销')) {
            if (!this.showWeigh.skin) {
              this.temporaryWeighObj.skin = newV;
            } else {
              this.temporaryWeighObj.hair = newV;
              this.isweigh = Number(this.currentClean) < 0;
            }
          } else if ( (this.isweight) && (this.weighList.orderType == '外购')) {
            if (!this.showWeigh.hair) {
              this.temporaryWeighObj.hair = newV;
            } else {
              this.temporaryWeighObj.skin = newV;
              this.isweigh = Number(this.currentClean) < 0 || this.showWeigh.skin < newV && this
                  .showWeigh
                  .skin > 0;
            }
          }else if((this.weighList.orderType == '外购') && (!this.isweight)){
            if (!this.showWeigh.skin) {
              this.temporaryWeighObj.skin = newV;
              this.temporaryWeighObj.isWeightclean = newV;
            } else {
              this.temporaryWeighObj.isWeightclean = newV;
              this.isweigh = Number(this.currentClean) < 0;
            }
          }
        }
      },
      immediate: true,
      deep: true
    }
  },
  onPullDownRefresh() {
    if (!this.globalisconnect && !this.globalisUploadimg && this.globalisLogin) {
      if (!this.is_open_socket) {
        this.$store.dispatch('websocketInit')
        this.changeisconnect(false);
        console.log('称重的ws');
        uni.stopPullDownRefresh();
      } else {
        uni.stopPullDownRefresh();
      }
    }
  },
  onShow() {
    this.init();
    // this.realTimeWeigh = 0
    if (this.timer) {
      clearTimeout(this.timer)
    }
    this.timer = setTimeout(() => {
      if (!this.globalweigh) {
        console.log('称重时自动重连');
        // this.socketTask.close();
        this.changesocketTask(null);
        this.changereconnectNum({ connectNum: 1, isWeigh: true })
        this.$store.dispatch('websocketInit');

      }
    }, 3000)
    uni.showToast({
      title: '正在连接服务，请稍等',
      icon: 'none'
    })
  },
  onHide() {
    clearTimeout(this.timer)
  },
  onUnload() {
    clearTimeout(this.timer)
  },

  computed: {
    ...mapState(['globalinfraredStatus', 'globalWarning', 'globalisconnect', 'globalisUploadimg',
      'globalisLogin', 'socketTask','is_open_socket',
    ]),
    ...mapGetters(['globalweigh']),
    token() {
      return uni.getStorageSync('token');
    },
    roleType() {
      console.log(uni.getStorageSync('userInfo'),'roleType----称重页面')
      console.log(uni.getStorageSync('userInfo').type,'type----type')
      return uni.getStorageSync('userInfo').type;
    },
    weightStatus(){
      //称重是否异常   1.无车 2.连接中 3.正常;
      if(this.realTimeWeigh == 0){
        return '无车'
      }else if(!this.is_open_socket){
        return '连接中'
      }else if(this.is_open_socket  && this.realTimeWeigh){
        return '正常'
      }else{
        return '异常'
      }
    },
    weightStatusType(){
      switch (this.weightStatus) {
        case '无车':
          return 'error'
        case '连接中':
          return 'error'
        case '正常':
          return 'success'
        default:
          return 'error'
      }

    },
    // 加减煤按钮禁用与否
    addAndSubtractCoalDisabled() {
      return this.realTimeWeigh == 0;
    },
    // 是否放空按钮禁用
    isEvacuation() {
      if (this.weighList.orderType == '外销') {
        return (this.weighList.skin === 0 ? this.temporaryWeighObj.skin : this.weighList.skin) == this.temporaryWeighObj.hair;
      }
      if (this.weighList.orderType == '外购') {
        return (this.weighList.hair === 0 ? this.temporaryWeighObj.skin : this.weighList.hair) == this.temporaryWeighObj.hair;
      }
    },

    showWeigh() {
      return this.weighList.tmTaskCoalItems ? (this.weighList.tmTaskCoalItems[0] ? this
          .weighList.tmTaskCoalItems[0] : {}) : {}
    },
    // 称重历史
    weighHistory() {
      return this.weighList.tmTaskCoalItems ? this.weighList.tmTaskCoalItems : []
    },
    currentHair() {
      if (this.weighList.orderType == '外销') {
        return this.temporaryWeighObj.hair ? this.temporaryWeighObj.hair : ''
      }
      return this.temporaryWeighObj.hair ? this.temporaryWeighObj.hair : this.showWeigh.skin ? (this.showWeigh
          .skin || '') : (this.showWeigh.hair || '')
    },
    currentSkin() {
      return this.temporaryWeighObj.skin ? this.temporaryWeighObj.skin : (this.showWeigh.skin || '')
    },
    currentClean() {
      if (!this.currentSkin) return ''
      if (this.weighList.orderType == '外购') {
        return (this.currentHair - this.currentSkin).toFixed(2)
      } else {
        return !this.showWeigh.skin ? this.currentSkin : (this.currentHair - this.currentSkin) > 0 ? (this
            .currentHair - this.currentSkin).toFixed(2) : ''
      }

    },
    isWeightclean(){
      console.log(this.temporaryWeighObj,'his.temporaryWeighObj')
      return this.temporaryWeighObj.skin || ''
    },
    isweight(){
      if(this.isWeighing){
        if(this.isWeighing == '不回磅'){
          return false
        }else{
          return true
        }

      }else{
        return true
      }
    },

  },
  methods: {
    ...mapMutations(['changeweighHouseCode', 'changeisLogin', 'changeWeigh','changereconnectNum','changesocketTask']),
    init() {
      uni.showLoading({
        title: '加载中'
      })
      console.log(this.weighData.sceneId,'磅房----')
      // 获取称重信息
      // uni.request({   //根据磅房查询提煤单信息
      //   url: `${BaseUrl}/wrzs/jccoalweighhouse/getTmTaskCoalNoCar/${this.weighData.sceneId}`,
      //   method: 'GET',
      //   header: {
      //     Authorization: 'Bearer' + ' ' + uni.getStorageSync('token'),
      //     clientToc: 'Y',
      //     'CLIENT_TOC': 'Y',
      //   },
      //   success: (res) => {
      //     console.log(res,'res.datra----------')
      //     if(res.data.code == 0) {
      //       this.weighList = res.data;
      //       this.weighData.deptId = res.data.deptId;
      //       this.weighData.tmId = res.data.id;
      //       this.weighData.carNo = res.data.carNo;
      //       this.weighData.tmCode = res.data.code;
      //       this.weighData.filedId = res.data.filedId;
      //       this.noCarNo = res.data.noCarNo
      //       this.applyHouseId = res.data.applyHouseId
      //       this.status = res.data.status
      //       this.outBuy = (this.weighList.orderType.indexOf('销') !== -1) && this.showWeigh.skin > 0;
      //       // 继续卸货只有外购类型第二次会有
      //       this.canUnload = this.weighList.orderType === '外购' && this.showWeigh.hair > 0;
      //     }else {
      //       this.$u.toast(res.data.msg);
      //     }
      //   }
      // })
      let params = {}
      this.tmId ? params = { tmId: this.tmId, houseId: this.weighData.sceneId } : params = { houseId: this.weighData.sceneId }
      console.log(params,'参数===')
      this.$reqGet('getTmTaskCoalNoCar', params).then(res => {
        console.log(res, '提煤单信息');
        uni.hideLoading()
        if (res.code == 0) {
          this.weighList = res.data;
          this.weighData.deptId = res.data.deptId;
          this.weighData.tmId = res.data.id;
          this.weighData.carNo = res.data.carNo;
          this.weighData.tmCode = res.data.code;
          this.weighData.filedId = res.data.filedId;
          this.noCarNo = res.data.noCarNo
          this.applyHouseId = res.data.applyHouseId
          this.status = res.data.status
          this.outBuy = (this.weighList.orderType.indexOf('销') !== -1) && this.showWeigh.skin > 0;
          // 继续卸货只有外购类型第二次会有
          this.canUnload = this.weighList.orderType === '外购' && this.showWeigh.hair > 0;
        }else {
          this.weighList = {}
          this.$u.toast(res.msg ? res.msg : '占无磅单信息');
        }
      });
    },
    refreshClick() {
      this.init()
    },
    confirmWeigh() {  //点击确认称重按钮
      if (this.isConfirmWeighLoading == false) {
        this.isConfirmWeighLoading = true
        if(this.weighData.weigh != 0) {
          if (this.weighList.orderType == '外销') {
            if (this.weighList.skin ? (this.weighList.skin < this.realTimeWeigh ? true : false) : true) {
              this.saveWeigh();
            } else {
              this.$u.toast('毛重不能小于皮重');
              this.isConfirmWeighLoading = false;
            }
          } else {
            this.saveWeigh();
          }
        }else {
          this.$u.toast('未能获取地磅重量');
          this.isConfirmWeighLoading = false;
        }
      }
    },
    // 确认称重接口
    saveWeigh() {  //点击确认称重按钮
      // this.weighData.coalContactClean = this.coalContactClean;
      this.$reqPost('saveWeighYZY', this.weighData, 'json')
          .then(res => {
            console.log(res, '称重接口');
            if (res.code == 0) {
              this.$u.toast('称重成功');
              setTimeout(() => {
                uni.navigateBack({
                  delta: 1
                });
                this.isConfirmWeighLoading = false;
              }, 1000);
            } else {
              this.$u.toast('称重失败，请稍后重试' + (res.msg ? res.msg : ''));
            }
          })
          .catch(err => {
            this.isConfirmWeighLoading = false;
            console.log(err);
            this.$u.toast(err.msg ? err.msg : '称重失败');
          }).finally(() => {
        this.isConfirmWeighLoading = false;
      });
    },
    confirmRepeatWeigh() {  //复磅
      this.repeatWeighLoading = true
      if(this.weighData.weigh != 0) {
        this.$reqPost('reWeighYZY', this.weighData, 'json').then(res => {
          if (res.code == 0) {
            this.repeatWeighLoading = false;
            this.$u.toast('复磅成功');
            setTimeout(() => {
              uni.navigateBack({
                delta: 1
              });
            }, 1000);
          }else {
            this.$u.toast('复磅失败，请稍后重试' + (res.msg ? res.msg : ''));
          }
        }).finally(() => {
          this.repeatWeighLoading = false;
        })
      }else {
        this.$u.toast('未能获取地磅重量');
        this.repeatWeighLoading = false;
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.weighingDecive-item{
  min-height: 200rpx!important;
  .weigh-history {
    min-height: 200rpx!important;
  }
}
@mixin flex {
  display: flex;
  justify-content: space-between;
  align-items: center;
}

// 称重历史
.weighHistory-enter-active,
.weighHistory-leave-active {
  transition: opacity 0.5s ease;
}

.weighHistory-enter-from,
.weighHistory-leave-to {
  opacity: 0;
}

.weigh-history {
  width: 690rpx;
  height: 100%;
  min-height: 420rpx;
  margin: vww(10) auto vww(20);
  background: #ffffff;
  box-shadow: 4rpx 6rpx 51rpx 0rpx rgba(73, 120, 240, 0.11);
  border-radius: 20rpx;
  position: relative;
  font-size: 30rpx;
  font-weight: 300;
  color: #303030;
  overflow: hidden;

  .block-main {
    display: grid;
    grid-template-columns: auto;
    grid-template-rows: repeat(auto-fit, minmax(40rpx, 1fr));
    width: 94%;
    height: 100%;
    min-height: 380rpx;
    margin: vww(18) vww(7) vww(11) vww(17);
    gap: 10rpx 20rpx;

    .weigh-item {
      width: 100%;
      height: vww(80);
      @include flex;
      flex-direction: column;
      justify-content: space-around;
      align-items: flex-start;

      .item-block {
        width: 100%;
        height: vww(36);
        @include flex;
        justify-content: space-around;

        .item {
          min-width: vww(50);
          height: vww(45);
          font-size: 21rpx;
          font-weight: 400;
          color: #ffffff;
          text-align: center;
          line-height: vww(30);
          @include flex;

          .concrete {
            width: vww(36);
            height: vww(36);
          }

          .num {
            font-size: 40rpx;
            font-weight: 300;
            color: #303030;
          }
        }
      }
    }
  }
}

::v-deep.weighingDevice {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;

  .one {
    // flex: 3;
    height: 290rpx;
    margin: vww(10) vww(20) vww(20) vww(20);
    border-radius: vww(15);

    .top {
      height: 75%;
      display: flex;

      .top_left {
        flex: 3;
        font-size: vww(50);
        display: flex;
        align-items: center;
        justify-content: center;
        font-size: 74rpx;
        font-weight: 400;
        color: #ffffff;
        line-height: 69rpx;
        text-shadow: 0rpx 3rpx 14rpx rgba(0, 0, 0, 0.33);

        text {
          font-family: weighting;
        }
      }

      .top_right {
        display: flex;
        flex-direction: column;
        justify-content: center;
        flex: 2;
        font-size: 31rpx;
        font-weight: 300;
        color: #ffffff;

        view {
          display: flex;
          align-items: center;
        }
      }
    }

    .bottom {
      text-align: center;
      height: 25%;
      display: flex;
      justify-content: space-between;
      align-items: center;
      flex-direction: column;
      font-size: 28rpx;
      font-weight: 300;
      color: #d9e1fe;
    }
  }

  .middle-block {
    width: 690rpx;
    height: 386rpx;
    margin: vww(20) vww(15) vww(13);
    background: #ffffff;
    box-shadow: 0rpx 0rpx 14rpx 0rpx rgba(73, 120, 240, 0.14), 0rpx 7rpx 45rpx 0rpx rgba(73, 120, 240, 0.12);
    border-radius: 20rpx;
    @include flex;
    justify-content: center;
    overflow: hidden;

    .block-main {
      width: 650rpx;
      height: 350rpx;
      @include flex;
      flex-direction: column;
      margin-bottom: vww(20);
      position: relative;

      .first-line,
      .second-line {
        width: 90%;
        height: vww(44);

        .focusClass {
          color: #5b95fd;
        }

        .inputClass {
          border: 1px solid rgba(73, 95, 252, 0.6) !important;
          box-shadow: 0rpx 5rpx 13rpx 0rpx rgba(73, 95, 252, 0.6) !important;
          border-radius: 12rpx !important;
        }

        .isInputOrigin {
          background-color: #f4f4fc;
        }

        .input-container {
          border: 2px solid #c5c5c5;
          box-shadow: 0rpx 5rpx 13rpx 0rpx #c5c5c5;
          border-radius: 12rpx;
        }
      }

      .first-line {
        @include flex;
        position: relative;
        top: vww(8);
      }

      .second-line {
        @include flex;
      }
    }

    .block-sideline {
      width: 94%;
      height: vww(100);
      @include flex flex-direction: column;
      align-items: flex-start;

      .first-line {
        width: 100%;
      }

      .weigh-item {
        width: 100%;
        height: vww(36);
        @include flex justify-content: space-around;

        .item {
          min-width: vww(50);
          height: vww(45);
          font-size: 21rpx;
          font-weight: 400;
          color: #ffffff;
          text-align: center;
          line-height: vww(30);
          @include flex;

          .concrete {
            width: vww(36);
            height: vww(36);
          }

          .num {
            font-size: 40rpx;
            font-weight: 300;
            color: #303030;
          }
        }
      }
    }
  }

  .bottom-block {
    width: calc(100% - 60rpx);
    box-sizing: border-box;
    margin: 0 vww(15) vww(15) vww(15);
    background: #ffffff;
    box-shadow: 0rpx 0rpx 14rpx 0rpx rgba(73, 120, 240, 0.14), 0rpx 7rpx 45rpx 0rpx rgba(73, 120, 240, 0.12);
    border-radius: 20rpx;
    padding: 20rpx 0;
    box-sizing: border-box;
    @include flex;
    justify-content: center;
    overflow: hidden;

    .block-main {
      width: 94%;
      height: 420rpx;
      margin-top: vww(5);
      @include flex;
      justify-content: space-around;
      align-items: flex-start;
      flex-direction: column;
      overflow: hidden;

      .main-information {
        width: 100%;
        height: 28rpx;
        font-size: 28rpx;
        font-weight: 300;
        color: #303030;
        @include flex;
        justify-content: flex-start;
        overflow: hidden;

        .prefix {
          min-width: vww(60);
        }

        .suffix {
          flex: 1;
          margin-left: vww(12);
          text-align: left;
        }
      }
    }
  }

  .three {
    margin: 0 auto vww(5);
    margin-bottom: vww(60);
    width: 96%;
    display: grid;
    grid-template-columns: repeat(auto-fit, minmax(140rpx, 1fr));
    justify-content: center;
    gap: vww(10);
    color: #939393;

    .u-button {
      width: vww(70);
    }
  }

  .four {
    width: 100%;
    margin-top: vww(5);
    text-align: center;
  }
}

.secondary-confirmation__main {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  align-items: center;

  .secondary-child {
    display: flex;
    justify-content: space-between;
  }
}
.chengzhong-btn{
  width: 80%;
  margin: 0 auto;
}
.marginTop{
  margin-top: 20rpx;
}
.weighingDevice{
  .shuaxinBtn{
    width: calc(100% - 80rpx);
    margin: 20rpx auto 0;
    ::v-deep{
      .u-button--plain.u-button--primary{
        border-radius: 60rpx;
      }
      .u-button--normal{
        padding: 0 25rpx;
        font-size: 28rpx;
      }
    }
  }
}
</style>
